=== debian/control ===
Source: veracrypt
Section: non-free/utils
Priority: optional
Maintainer: Unit 193 <unit193@unit193.net>
Build-Depends: debhelper-compat (= 13),
 libayatana-appindicator3-dev,
 libpcsclite-dev,
 libfuse3-dev,
 libwxgtk3.2-dev | libwxgtk3.0-gtk3-dev,
 pkgconf,
 yasm [any-i386 any-amd64]
Rules-Requires-Root: no
Standards-Version: 4.7.0
Homepage: https://veracrypt.fr/

Package: veracrypt
Architecture: any
Depends:
 dmsetup,
 kmod,
 sudo,
 ${misc:Depends},
 ${shlibs:Depends}
Recommends:
 exfatprogs | exfat-utils,
 ntfs-3g,
 xdg-utils
Description: Cross-platform on-the-fly encryption
 VeraCrypt provides cross-platform on-the-fly encryption for Linux, MacOS X and
 Windows. It can encrypt filesystems stored either within a file or on disk
 partitions. Supported encryption algorithms include AES, Serpent and Twofish.
 The current version uses the XTS mode of disk encryption. In addition,
 VeraCrypt supports "hidden volumes" - unidentifiable volumes present in the
 free-space of a VeraCrypt volume.
